/*jshint browser: false */
/*global module */

module.exports = function(grunt) {
  grunt.initConfig({
    pkg: grunt.file.readJSON('package.json'),

    sass: {
      dist: {
        files: {
          'css/touch.css': 'scss/touch.scss'
        },
        options: {
          sourcemap: 'none'
        }
      }
    },

    autoprefixer: {
      'css/touch.css': 'css/touch.css'
    },

    jshint: {
      all: [
      'Gruntfile.js',
      'js/app.js',
      'js/services/*.js',
      'js/controllers/*.js',
      'js/filters/*.js'
      ]
    },
  });

  grunt.loadNpmTasks('grunt-contrib-sass');
  grunt.loadNpmTasks('grunt-contrib-jshint');
  grunt.loadNpmTasks('grunt-autoprefixer');

  grunt.registerTask('default', ['jshint', 'sass', 'autoprefixer']);
};
