;(function() {
  'use strict';

  angular.module('jetztAutoVerkaufenApp')

  .controller('form2Controller', function($scope, dataService, networkService) {
    $scope.sessionData = dataService;

    $scope.showValuation = function(event) {
      var builtDateID = dataService.model.builtDateID;
      var mainTypeSubDetailID = dataService.model.mainTypeSubDetailID;
      var kilometers = dataService.model.kilometers;
      var emailAddress = dataService.model.emailAddress;
      var phoneNumber = dataService.model.phoneNumber;

      networkService.createNewCar(
        builtDateID, mainTypeSubDetailID, kilometers, emailAddress, phoneNumber,
        function successCallback(carHash) {
          dataService.model.carHash = carHash;
          $scope.push(event, 'result');
        },
        function errorCallback(errors) {
          for (var i = errors.length - 1; i >= 0; i--) {
            var error = errors[i];

            if (error.hasOwnProperty('code') && error.code === 25) {
              $scope.schritt3.input.$setValidity('email', false);
            } else {
              console.log('Error: ' + error);
            }
          }
        });
    };

    // This is executed every time the view is loaded
    $scope.$on('$viewContentLoaded', function() {
      window.scrollTo(0, 0);

      $scope.kilometers = [
        {"value":"5000","label":"Bis 5.000"},
        {"value":"10000","label":"Bis 10.000"},
        {"value":"20000","label":"Bis 20.000"},
        {"value":"30000","label":"Bis 30.000"},
        {"value":"40000","label":"Bis 40.000"},
        {"value":"60000","label":"Bis 60.000"},
        {"value":"80000","label":"Bis 80.000"},
        {"value":"100000","label":"Bis 100.000"},
        {"value":"125000","label":"Bis 125.000"},
        {"value":"150000","label":"Bis 150.000"},
        {"value":"200000","label":"Mehr als 150.000"}
      ];
    });
  });
})();
