;(function() {
  'use strict';

  angular.module('jetztAutoVerkaufenApp')

  .factory('dataService', function($rootScope) {
    var service = {
      model: {

        // home
        manufacturerID: null,
        carTypeID: null,
        builtDateID: null,

        // form1
        bodyTypeID: null,
        mainTypeDetailID: null,
        mainTypeSubDetailID: null,

        // form2
        kilometers: null,
        emailAddress: null,
        phoneNumber: null,

        // result
        carHash: null,
        branchID: null,
        firstname: null,
        lastname: null,

        // appointment
        selectedBranch: null,
        selectedBranchTime: null
      },

      cache: {
        manufacturers: null,
        carTypes: null,
        builtDates: null,
        bodyTypes: null,
        mainTypeDetails: null,
        mainTypeSubDetails: null,
        branches: null
      },

      resetCarTypesOnwards: function() {
        this.model.carTypeID = this.cache.carTypes = null;
        this.resetBuiltDatesOnwards();
      },

      resetBuiltDatesOnwards: function() {
        this.model.builtDateID = this.cache.builtDates = null;
        this.resetBodyTypesOnwards();
      },

      resetBodyTypesOnwards: function() {
        this.model.bodyTypeID = this.cache.bodyTypes = null;
        this.resetMainTypeDetailsOnwards();
      },

      resetMainTypeDetailsOnwards: function() {
        this.model.mainTypeDetailID = this.cache.mainTypeDetails = null;
        this.resetMainTypeSubDetailsOnwards();
      },

      resetMainTypeSubDetailsOnwards: function() {
        this.model.mainTypeSubDetailID = this.cache.mainTypeSubDetails = null;
        this.resetKilometersOnwards();
      },

      resetKilometersOnwards: function() {
        this.model.kilometers = null;
        this.resetCarHashOnwards();
      },

      resetCarHashOnwards: function() {
        this.model.carHash = null;
        this.resetBranches();
      },

      resetBranches: function() {
        this.model.branchID = this.cache.branches = null;
        this.resetSelectedBranch();
      },

      resetSelectedBranch: function() {
        this.model.selectedBranch = null;
        this.resetSelectedBranchTime();
      },

      resetSelectedBranchTime: function() {
        this.model.selectedBranchTime = null;
      },

      saveState: function() {
        sessionStorage.model = angular.toJson(this.model);
        sessionStorage.cache = angular.toJson(this.cache);
      },

      restoreState: function() {
        this.model = angular.fromJson(sessionStorage.model);
        this.model = angular.fromJson(sessionStorage.cache);
      }
    };

    $rootScope.$on('savestate', service.saveState);
    $rootScope.$on('restorestate', service.restoreState);

    return service;
  });
})();
